We are frequently asked what would be useful as a contribution to the project. There's evergreen advice below, as well as a few more specific wish list ideas from our team. 

## Always useful

* If you're unfamiliar with Metasploit or looking to tackle some smaller projects, we'll thank you a million times over to [look at our issue queue](https://github.com/rapid7/metasploit-framework/issues). Submitting bug fixes, testing reported issues, and answering questions are all extremely helpful. 
* See an issue whose submitter didn't give us much information about replication, their target environment, or their version of Metasploit? See if you can get some clarity to help out, or better yet, test it yourself!
* You can also sort out [feature requests in our issue queue](https://github.com/rapid7/metasploit-framework/issues?q=is%3Aopen+is%3Aissue+label%3Afeature). See something that sounds cool? Fantastic! Tinker away and submit a PR.
* Write docs! Adding documentation is one of the best ways to help current and future users (especially beginners) and save developers pain.
* Check out [PRs in the attic](https://github.com/rapid7/metasploit-framework/pulls?q=is%3Apr+is%3Aclosed+label%3Aattic) and see if you can pick up where another contributor left off or got stuck.

## A few other ideas

* Implement transport switching for Mettle. 
* Improve network evasions across multiple protocols. Client headers abound with telltales!
* Add UPnP recon and fuzzing library support (there's a fun [thread on this idea here](https://github.com/rapid7/metasploit-framework/issues/11452#issuecomment-466495803))
